#include "light.h"

Vect3 Light::lit_color(Vect3 V, Vect3 N, Vect3 P){

    const Vect3 L = (this->pos - P).normalized();
    //MATERIAL
    const Scalar specular_exponent = 80;
    const Vect3 diffuse_color(0.5, 1, 0.5);
    const Vect3 specular_color(1.5, 1.5, 1.5);

    //LIGHTING
    Vect3 H = nlerp(L, V, 0.5);
    Scalar diffuse_factor = std::max(dot(N, L), 0.0);
    Scalar specular_factor = std::pow(std::max(dot(N, H), 0.0), specular_exponent);

    return (diffuse_factor*intensity)*diffuse_color + 
            (specular_factor*intensity)*specular_color;
}