#include "ray.h"
#include "sphere.h"

Scalar Ray::intersect(Sphere s){
    
    Vect3 v = origin - s.center;
    Scalar a = 1, b = 2*dot(v, direction), c = dot(v,v) - s.radius*s.radius;

    Scalar delta = b*b - 4*a*c;

    if(delta < 0) return MISS;

    Scalar k = (-b - sqrt(delta))/(2*a);

    if(k < 0) return MISS;

    return k;
}