#pragma once

#include "vect3.h"

struct Sphere;

const Scalar MISS = +INFINITY;

struct Ray{
    Vect3 origin, direction;

    Ray(Vect3 o, Vect3 d) {
        origin = o;
        direction = d.normalized();
    }

    Vect3 pos (Scalar k) const {
        return origin + k * direction;
    }

    Scalar intersect(Sphere s);
};