#include "scene.h"

void Scene::populate(){
    spheres.clear();
    lights.clear();
     spheres.push_back(
        Sphere(
            Vect3 (0.0f, -100.0f, 10.0f),
            100
    ));
    spheres.push_back(
        Sphere(
            Vect3 (1.0f, 0.0f, 2.0f),
            1.5
    ));
    spheres.push_back(
        Sphere(
            Vect3 (-1.0f, 1.0f, 3.0f),
            2.5
    ));
    spheres.push_back(
        Sphere(
            Vect3 (3.0f, 2.0f, 2.5f),
            0.5
    ));

    Light l0;
    l0.pos = Vect3(50, 50, -20);
    l0.intensity = 0.75;

    Light l1 = l0;
    l1.pos = Vect3(0, 34, 20);
    l1.intensity = 0.45;

    Light l2 = l1;
    l1.pos = Vect3(0, 0.25, -4.5);
    l1.intensity = 0.10;

    lights.push_back(l0);
    lights.push_back(l1);
    lights.push_back(l2);
}

bool Scene::is_in_shadow(Vect3 p, const Light &light){
    Ray r(p, light.pos - p);
    for (Sphere &s: spheres){
        if (r.intersect(s) != MISS)
            return true;
    }
    return false;
}

Vect3 Scene::lighting (Vect3 V, Vect3 N, Vect3 P){

    Vect3 res_color(0, 0, 0);

    for (Light &light: lights){
        if(!is_in_shadow(P, light)){
            res_color += light.lit_color(V, N, P);
        }
    }

    return res_color;
}