#include "vect3.h"

/*class Vect3 {
public:
    double x, y, z;
};*/

void Vect3::print_coordinates() const {
        std::cout<<"X,Y,Z: " << x << "," << y << "," << z << std::endl;
}

Scalar dot(const Vect3 &a, const Vect3 &b) {
    return a.x * b.x + a.y * b.y + a.z * b.z;
}

Vect3 cross(const Vect3 &a, const Vect3 &b) {
    return Vect3(
        a.y * b.z - a.z * b.y,
        a.z * b.x - a.x * b.z,
        a.x * b.y - a.y * b.x
    );
}

Scalar degrees_between (const Vect3 &q, const Vect3 &p) {
    Scalar csn_by_l = dot(q, p)/(q.length()*p.length());
    Scalar sn_by_l = cross(q, p).length()/(q.length()*p.length());
    return rad_to_deg(std::atan2(sn_by_l, csn_by_l));
}

/*
Scalar degrees_between(const Vec3 &a, const Vec3 &b) {
    Scalar cosineTimesLengths = dot(a, b);
    Scalar sineTimesLengths = cross(a, b).length();

    return to_deg(std::atan2(sineTimesLengths, cosineTimesLengths));
}
*/